commit f9451b6f3f0d98622ebe8ab0d309e0a3c53b5ca3
Merge: 899a9b79e71 8a491a6a757
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Tue Aug 13 15:56:54 2024 +0530

    Merge pull request #5369 from VarunNagaraju/post-EOL-3
    
    PS-9301 Backport bug fixes from MySQL 8.0.38

commit 5c46f67af1f2bed2103b0d565d0d15bd06d95352
Author: Vadim Yalovets <vadim.yalovets@percona.com>
Date:   Wed Aug 14 15:30:37 2024 +0300

    RM-1419 PS-5.7.44-51 (post-EOL 3)


commit 813837bab2fb462f83331614fc5a55548a2c0b2f
Merge: f9451b6f3f0 5c46f67af1f
Author: Vadim Yalovets <vadim.yalovets@percona.com>
Date:   Thu Aug 15 12:55:57 2024 +0300

    Merge pull request #5379 from adivinho/release-5.7.44-51
    
    RM-1419 PS-5.7.44-51 (post-EOL 3)

commit 786fe33650a909f4d8a79057ea01ede0a62fb392
Merge: f9451b6f3f0 813837bab2f
Author: Vadim Yalovets <vadim.yalovets@percona.com>
Date:   Wed Aug 28 10:39:10 2024 +0300

    Merge pull request #5386 from percona/release-5.7.44-51
    
    RM-1419 PS-5.7.44-51 (post-EOL 3)

commit d71d742d09d13bda633e329fe9065fc90f6597c8
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Mon Aug 19 13:43:19 2024 +0530

    PS-9352 Avoid out of bounds access due to ulong bitmask
    
    https://perconadev.atlassian.net/browse/PS-9352
    
    Bug#35507223 mysql/mysql-server@3a27636ac1b
    
    In MySQL 8.0 there are cases in which ~NO_ACCESS bitmask is passed as
    "access" argument to get_privilege_desc() function. In the past, before
    Bug#35507223 was fixed, this could have caused crash due to out of bounds
    array access.
    
    Since we can't totally exclude that the same thing is possible in 5.7 branch
    we have decided to fix potential problem there as well, by adding simple check
    for out of bounds array access.

diff --git a/sql/auth/sql_authorization.cc b/sql/auth/sql_authorization.cc
index 7e16dd30fa4..2e3df8e9986 100644
--- a/sql/auth/sql_authorization.cc
+++ b/sql/auth/sql_authorization.cc
@@ -2931,6 +2931,7 @@ void get_privilege_desc(char *to, uint max_length, ulong access)
     max_length--;                               // Reserve place for end-zero
     for (pos=0 ; access ; pos++, access>>=1)
     {
+      if (pos >= array_elements(command_lengths)) break;
       if ((access & 1) &&
           command_lengths[pos] + (uint) (to-start) < max_length)
       {

